import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.io.*;
 
/**
 *
 * A complete Java class that shows how to open a URL, then read data (text) from that URL,
 * HttpURLConnection class (in combination with an InputStreamReader and BufferedReader).
 *
 * @author alvin alexander, devdaily.com.
 *
 */
public class VeryPDFCloudAPI
{
  public static void main(String[] args) throws Exception
  {
  		System.out.println("[Message] Enter main application...");

    	String strOutFile = "verypdf.jpg";
			String strCloudAPIURL = "http://online.verypdf.com/api/?apikey=XXXX-XXXX-XXXX-XXXX&app=html2image&infile=http://www.verypdf.com&outfile=" + strOutFile;
			VeryPDFCloudAPIConverter(strCloudAPIURL, strOutFile);

    	strOutFile = "verypdf.pdf";
			strCloudAPIURL = "http://online.verypdf.com/api/?apikey=XXXX-XXXX-XXXX-XXXX&app=html2pdf&infile=http://www.verypdf.com&outfile=" + strOutFile;
			VeryPDFCloudAPIConverter(strCloudAPIURL, strOutFile);
  }
  
	public static void VeryPDFCloudAPIConverter(String strCloudAPIURL, String strOutFile) throws Exception
	{
      String strResults = doHttpUrlConnectionAction(strCloudAPIURL);
      strResults = strResults.replace("[Output]", "");
      strResults = strResults.replace("<br>", "");
      strResults = strResults.replace(" ", "");
      System.out.println("[CloudAPI Return] " + strResults);
      File file = new File(".");
      String strLocalFile = file.getCanonicalPath()+"\\"+strOutFile;
			DownloadFileFromURL(strResults, strLocalFile);
	}
	
	public static void DownloadFileFromURL(String strFileURL, String destinationFile) throws IOException
	{
      System.out.println("[From] "+strFileURL);
      System.out.println("[To] "+destinationFile);

			URL url = new URL(strFileURL);
			InputStream is = url.openStream();
			OutputStream os = new FileOutputStream(destinationFile);
	
			byte[] b = new byte[2048];
			int length;
	
			while ((length = is.read(b)) != -1) {
				os.write(b, 0, length);
			}
	
			is.close();
			os.close();
	}
	/**
   * Returns the output from the given URL.
   *
   * I tried to hide some of the ugliness of the exception-handling
   * in this method, and just return a high level Exception from here.
   * Modify this behavior as desired.
   *
   * @param desiredUrl
   * @return
   * @throws Exception
   */
  private static String doHttpUrlConnectionAction(String desiredUrl) throws Exception
  {
  	System.out.println("[CloudAPI URL] " + desiredUrl);
  	
    URL url = null;
    BufferedReader reader = null;
    StringBuffer stringBuffer;
 
    try
    {
      // create the HttpURLConnection
      url = new URL(desiredUrl);
      HttpURLConnection connection = (HttpURLConnection) url.openConnection();
       
      // just want to do an HTTP GET here
      connection.setRequestMethod("GET");
       
      // uncomment this if you want to write output to this url
      //connection.setDoOutput(true);
       
      // give it 15 seconds to respond
      //connection.setReadTimeout(15*1000);
      connection.connect();
 
      // read the output from the server
      reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
      stringBuffer = new StringBuffer();
 
      String line = null;
      while ((line = reader.readLine()) != null)
      {
        	stringBuffer.append(line + "\n");
      }
      return stringBuffer.toString();
    }
    catch (Exception e)
    {
      e.printStackTrace();
      throw e;
    }
    finally
    {
      // close the reader; this can throw an exception too, so
      // wrap it in another try/catch block.
      if (reader != null)
      {
        try
        {
          reader.close();
        }
        catch (IOException ioe)
        {
          ioe.printStackTrace();
        }
      }
    }
  }
}
